<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomSaleShipGroupList StructType
 * @subpackage Structs
 */
class CustomSaleShipGroupList extends AbstractStructBase
{
    /**
     * The customSaleShipgroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSaleShipGroup[]
     */
    public $customSaleShipgroup;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for CustomSaleShipGroupList
     * @uses CustomSaleShipGroupList::setCustomSaleShipgroup()
     * @uses CustomSaleShipGroupList::setReplaceAll()
     * @param \StructType\CustomSaleShipGroup[] $customSaleShipgroup
     * @param bool $replaceAll
     */
    public function __construct(array $customSaleShipgroup = array(), $replaceAll = true)
    {
        $this
            ->setCustomSaleShipgroup($customSaleShipgroup)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get customSaleShipgroup value
     * @return \StructType\CustomSaleShipGroup[]|null
     */
    public function getCustomSaleShipgroup()
    {
        return $this->customSaleShipgroup;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSaleShipgroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSaleShipgroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSaleShipgroupForArrayConstraintsFromSetCustomSaleShipgroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customSaleShipGroupListCustomSaleShipgroupItem) {
            // validation for constraint: itemType
            if (!$customSaleShipGroupListCustomSaleShipgroupItem instanceof \StructType\CustomSaleShipGroup) {
                $invalidValues[] = is_object($customSaleShipGroupListCustomSaleShipgroupItem) ? get_class($customSaleShipGroupListCustomSaleShipgroupItem) : sprintf('%s(%s)', gettype($customSaleShipGroupListCustomSaleShipgroupItem), var_export($customSaleShipGroupListCustomSaleShipgroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSaleShipgroup property can only contain items of type \StructType\CustomSaleShipGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSaleShipgroup value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSaleShipGroup[] $customSaleShipgroup
     * @return \StructType\CustomSaleShipGroupList
     */
    public function setCustomSaleShipgroup(array $customSaleShipgroup = array())
    {
        // validation for constraint: array
        if ('' !== ($customSaleShipgroupArrayErrorMessage = self::validateCustomSaleShipgroupForArrayConstraintsFromSetCustomSaleShipgroup($customSaleShipgroup))) {
            throw new \InvalidArgumentException($customSaleShipgroupArrayErrorMessage, __LINE__);
        }
        $this->customSaleShipgroup = $customSaleShipgroup;
        return $this;
    }
    /**
     * Add item to customSaleShipgroup value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSaleShipGroup $item
     * @return \StructType\CustomSaleShipGroupList
     */
    public function addToCustomSaleShipgroup(\StructType\CustomSaleShipGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSaleShipGroup) {
            throw new \InvalidArgumentException(sprintf('The customSaleShipgroup property can only contain items of type \StructType\CustomSaleShipGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSaleShipgroup[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\CustomSaleShipGroupList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
